#include <bits/stdc++.h>
#define maxN 500005

using namespace std;

int a[maxN],n,i,j,ans,tmp,res;

int dis(int x,int y){
int tmp=1<<(y+1);
x%=tmp;
tmp/=2;
if(x>=tmp) return 0;
if(tmp-x<x+1) return tmp-x;
else return -(x+1);
}

int main()
{
    ans=INT_MAX;
    cin>>n;
    for(i=0;i<n;i++) cin>>a[i];
    for(j=0;j<30;j++){
        res=0;
        int pom=0;
        for(i=0;i<n;i++){
            tmp=dis(a[i],j);
            res+=abs(tmp);
            pom^=(a[i]+tmp);
        }
        if(pom==0) res++;
        ans=min(ans,res);
    }
    cout<<ans<<endl;
    return 0;
}